package wikipediasearch
{

	import org.puremvc.as3.patterns.facade.Facade;
	
	import wikipediasearch.controller.ApplicationStartupCmd;
	import wikipediasearch.controller.SearchCommand;
	import wikipediasearch.view.Main;
	
	public class ApplicationFacade extends Facade
	{
		// Définition des noms de notification
		// -> notification de démarrage de l'application
		public static const STARTUP:String = "startup";
		
		public static const WIKI_SEARCH:String = "WIKI_SEARCH";
		public static const WIKI_SEARCH_SUCCESS:String = "WIKI_SEARCH_SUCCESS";
		public static const WIKI_SEARCH_FAULT:String = "WIKI_SEARCH_FAULT";
		
		public static const WIKI_SELECT_TITLE:String = "WIKI_SELECT_TITLE";
		public static const WIKI_UNSELECT_TITLE:String = "WIKI_UNSELECT_TITLE";
		
		public function ApplicationFacade()
		{
			super();
		}
		
		// Singleton instance
		public static function getInstance():ApplicationFacade
		{
			if (instance == null)
				instance = new ApplicationFacade();
			return instance as ApplicationFacade;
		}
		
		public function startup(app:wikipediasearch.view.Main):void
		{
			// distribution de la notification STARTUP depuis la vue app
			sendNotification(STARTUP, app);
	 	}
		
		protected override function initializeController():void
		{
			trace("initializeController: register commands");
			super.initializeController();
			
			// register commands
			registerCommand(STARTUP, ApplicationStartupCmd);
			registerCommand(WIKI_SEARCH, SearchCommand);
		}
	}
}